﻿define([
    "dojo/_base/declare",
    "dojo/_base/Deferred",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/Stateful",

    "epi/dependency",
    "epi/shell/_StatefulGetterSetterMixin",

    "epi-cms/contentediting/ContentActionSupport",
    "epi-cms/widget/ContentTreeStoreModel"
    ],
function (
    declare,
    Deferred,
    lang,
    array,
    Stateful,

    dependency,
    _StatefulGetterSetterMixin,

    ContentActionSupport,
    ContentTreeStoreModel
    ) {

    // module:
    //		commerce/widget/CatalogEntryListViewModel
    // summary:
    //		View model object for the CatalogEntry list.

    return declare("commerce.widget.CatalogEntryListViewModel", ContentTreeStoreModel, {

        // contentClasses: [protected] Array
        //		The set of content types to be taken into account.
        contentClasses: ['epi.cms.commerce.catalogentry'],

        _optionIgnore: { ignore: ["contentClasses"], sort: [{ attribute: "name", descending: false}] },

        // The catalog content data
        contentData: null,

        _commercerRootId: 0,

        constructor: function (params) {
            lang.mixin(this, params);
            this._commerceRootId = dependency.resolve("commerce.Application").getCommerceRoot();
        },

        postscript: function () {
            this.inherited(arguments);
        },

        canDelete: function (item) {
            // summary:
            //		Determine whether the given item is able to be deleted by the current user.
            // tags:
            //		public

            // TODO: return ContentActionSupport.hasAccess(item.accessMask, ContentActionSupport.accessLevel.Delete);
            return false;   // currently, we do not allow to delete
        },

        isAncestor: function (itemToMove, target) {
            // summary:
            //		Checks to see if the itemToMove is an ancestor of the target.

            // since we don't have entry as parent of another entry, just simply return false.
            return false;
        }
    });
});
